import _extends from 'babel-runtime/helpers/extends';
import _defineProperty from 'babel-runtime/helpers/defineProperty';
import _toConsumableArray from 'babel-runtime/helpers/toConsumableArray';
import * as React from 'react';
import classNames from 'classnames';
import { antDesignIcons } from '@ant-design/icons';
import ReactIcon from '@ant-design/icons-react';
import createFromIconfontCN from './IconFont';
import { svgBaseProps } from './utils';
import warning from '../_util/warning';
ReactIcon.add.apply(ReactIcon, _toConsumableArray(antDesignIcons));
var Icon = function Icon(props) {
    var _classNames;

    var title = props.title,
        className = props.className,
        onClick = props.onClick,
        style = props.style,
        type = props.type,
        Component = props.component,
        viewBox = props.viewBox,
        spin = props.spin,
        svgClassName = props.svgClassName,
        _props$svgStyle = props.svgStyle,
        svgStyle = _props$svgStyle === undefined ? {} : _props$svgStyle,
        children = props.children;

    warning(Boolean(type || Component || children), 'Icon should have `type` prop or `component` prop or `children`.');
    var classString = classNames((_classNames = {}, _defineProperty(_classNames, 'anticon', true), _defineProperty(_classNames, 'anticon-' + type, Boolean(type)), _classNames), className);
    var svgClassString = classNames(_defineProperty({}, 'anticon-spin', !!spin || type === 'loading'), svgClassName);
    // component > children > type
    if (Component) {
        var innerSvgProps = _extends({}, svgBaseProps, { className: svgClassString, style: svgStyle, viewBox: viewBox });
        if (!viewBox) {
            delete innerSvgProps.viewBox;
        }
        return React.createElement(
            'i',
            { className: classString, title: title, style: style, onClick: onClick },
            React.createElement(
                Component,
                innerSvgProps,
                children
            )
        );
    }
    if (children) {
        warning(Boolean(viewBox), 'Make sure that you provide correct `viewBox`' + ' prop (default `0 0 1024 1024`) to Icon.');
        var _innerSvgProps = _extends({}, svgBaseProps, { className: svgClassString, style: svgStyle });
        return React.createElement(
            'i',
            { className: classString, title: title, style: style, onClick: onClick },
            React.createElement(
                'svg',
                _extends({}, _innerSvgProps, { viewBox: viewBox }),
                children
            )
        );
    }
    if (type) {
        return React.createElement(
            'i',
            { className: classString, title: title, style: style, onClick: onClick },
            React.createElement(ReactIcon, { className: svgClassString, type: type, style: svgStyle })
        );
    }
    return React.createElement('i', { className: classString, title: title, style: style, onClick: onClick });
};
Icon.displayName = 'Icon';
Icon.createFromIconfontCN = createFromIconfontCN;
export default Icon;